BEGIN
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ATTRIBUTE_LOCALE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ATTRIBUTE_LOCALE_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'BULK_DATA_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM BULK_DATA_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ATTRIBUTE_LOCALE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW ATTRIBUTE_LOCALE_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'BULK_DATA_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW BULK_DATA_V';
                END LOOP;
END;
/

CREATE VIEW attribute_locale_v AS
SELECT
    attr.attribute_key,
    attr.attribute_type,
    attr.entity_type,
    map.label_map localized_key,
    map.label_map_key locale
FROM
    attribute_definition attr
    LEFT JOIN localized_label_map map ON attr.localized_display_name = map.localized_label
WHERE
    attr.entity_type IN ('USER', 'PERMISSION', 'ACCOUNT', 'GROUP')
AND attr.attribute_type <> 'INTERNAL'
AND attr.attribute_state = 'ACTIVE'
ORDER BY attr.attribute_key;

CREATE VIEW bulk_data_v AS 
  SELECT ds.name source_name,
    dp.id,
    dp.data_producer_type,
    dp.end_time,
    TO_CHAR(dp.message) message,
    dp.start_time,
    dp.status,
    afeed.id advisor_feed,
    afeed.source_type,
    afeed.entity_type,
    afeed.name,
    afeed.description,
   afeed.configuration configuration
   FROM data_production dp
     JOIN advisor_feed_curation afc ON afc.id = dp.id
     JOIN advisor_feed afeed ON afc.advisor_feed = afeed.id
     LEFT JOIN data_source ds ON ds.id = afeed.application
UNION ALL
 SELECT ds.name source_name,
    dp.id,
    dp.data_producer_type,
    dp.end_time,
    TO_CHAR(dp.message) message,
    dp.start_time,
    dp.status,
    afeed.id advisor_feed,
    afeed.source_type,
    afeed.entity_type,
    afeed.name,
    afeed.description,
    afeed.configuration configuration
   FROM data_production dp
     JOIN advisor_feed_generation afg ON afg.id = dp.id
     JOIN advisor_feed afeed ON afg.advisor_feed = afeed.id
     LEFT JOIN data_source ds ON ds.id = afeed.application;

GRANT SELECT ON igops.attribute_locale_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM attribute_locale_v FOR igops.attribute_locale_v;

GRANT SELECT ON igops.bulk_data_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM bulk_data_v FOR igops.bulk_data_v;